/* Tool.h
Defines the Tool class
(C) 2000 N. Douglas
15th May 2000
*/

#include "common.h"
#include "windows.h"

class WaterEngine;

class Tool
{
public:
	WaterEngine *we;
	HDC dc;
	int x1,y1,x2,y2;
	int mods;
	int par1;
	bool lockX, lockY;

	virtual void begin()=0;
	virtual void poll()=0;
	virtual void end()=0;
};

#define TOOL_BUILDMODS(lb, rb, shft) ((lb ? (1<<2) : 0) | (rb ? (1<<0) : 0) | (shft ? (1<<3) : 0))

#define TOOL_ISRBUTTON(mods) ((mods & (1<<0))!=0)
#define TOOL_ISLBUTTON(mods) ((mods & (1<<2))!=0)
#define TOOL_ISSHIFTED(mods) ((mods & (1<<3))!=0)

class ToolLine : public Tool
{
private:
	HPEN drawingpen;

public:
	ToolLine::ToolLine();
	ToolLine::~ToolLine();

	void ToolLine::begin();
	void ToolLine::poll();
	void ToolLine::end();

	virtual u32 getcol() const
	{
		return 0x00ffffff;
	}
};

class ToolCap : public Tool
{
private:
	HPEN drawingpen;

public:
	ToolCap::ToolCap();
	ToolCap::~ToolCap();

	void ToolCap::begin();
	void ToolCap::poll();
	void ToolCap::end();
};

class ToolAFilter : public ToolLine
{
public:
	ToolAFilter::ToolAFilter();

	u32 ToolAFilter::getcol() const;
};
class ToolRFilter : public ToolLine
{
public:
	ToolRFilter::ToolRFilter();

	u32 ToolRFilter::getcol() const;
};
class ToolBFilter : public ToolLine
{
public:
	ToolBFilter::ToolBFilter();

	u32 ToolBFilter::getcol() const;
};

class ToolPumpUp : public Tool
{
private:
	HPEN drawingpenO, drawingpenF;

public:
	ToolPumpUp::ToolPumpUp();
	ToolPumpUp::~ToolPumpUp();

	void ToolPumpUp::begin();
	void ToolPumpUp::poll();
	void ToolPumpUp::end();
};

class ToolPumpLeft : public Tool
{
private:
	HPEN drawingpenO, drawingpenF;

public:
	ToolPumpLeft::ToolPumpLeft();
	ToolPumpLeft::~ToolPumpLeft();

	void ToolPumpLeft::begin();
	void ToolPumpLeft::poll();
	void ToolPumpLeft::end();
};

class ToolPumpRight : public Tool
{
private:
	HPEN drawingpenO, drawingpenF;

public:
	ToolPumpRight::ToolPumpRight();
	ToolPumpRight::~ToolPumpRight();

	void ToolPumpRight::begin();
	void ToolPumpRight::poll();
	void ToolPumpRight::end();
};

